using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Package;
namespace CMSMicroservice.Protobuf.Validator.Package;

public class CreateNewPackageRequestValidator : AbstractValidator<CreateNewPackageRequest>
{
    public CreateNewPackageRequestValidator()
    {
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.Description)
            .NotEmpty();
        RuleFor(model => model.ImagePath)
            .NotEmpty();
        RuleFor(model => model.Price)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewPackageRequest>.CreateWithOptions((CreateNewPackageRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
